--- old/usr/src/uts/common/fs/zfs/spa.c	Mon Aug  5 17:26:53 2019
+++ new/usr/src/uts/common/fs/zfs/spa.c	Mon Aug  5 17:26:53 2019
@@ -2237,88 +2392,44 @@
 	return (total);
 }
 
+/*
+ * Load an existing storage pool, using the pool's builtin spa_config as a
+ * source of configuration information.
+ */
 static int
-spa_verify_host(spa_t *spa, nvlist_t *mos_config)
+spa_load_impl(spa_t *spa, uint64_t pool_guid, nvlist_t *config,
+    spa_load_state_t state, spa_import_type_t type, boolean_t mosconfig,
+    char **ereport)
 {
-	uint64_t hostid;
-	char *hostname;
-	uint64_t myhostid = 0;
-
-	if (!spa_is_root(spa) && nvlist_lookup_uint64(mos_config,
-	    ZPOOL_CONFIG_HOSTID, &hostid) == 0) {
-		hostname = fnvlist_lookup_string(mos_config,
-		    ZPOOL_CONFIG_HOSTNAME);
-
-		myhostid = zone_get_hostid(NULL);
-
-		if (hostid != 0 && myhostid != 0 && hostid != myhostid) {
-			cmn_err(CE_WARN, "pool '%s' could not be "
-			    "loaded as it was last accessed by "
-			    "another system (host: %s hostid: 0x%llx). "
-			    "See: http://illumos.org/msg/ZFS-8000-EY",
-			    spa_name(spa), hostname, (u_longlong_t)hostid);
-			spa_load_failed(spa, "hostid verification failed: pool "
-			    "last accessed by host: %s (hostid: 0x%llx)",
-			    hostname, (u_longlong_t)hostid);
-			return (SET_ERROR(EBADF));
-		}
-	}
-
-	return (0);
-}
-
-static int
-spa_ld_parse_config(spa_t *spa, spa_import_type_t type)
-{
 	int error = 0;
-	nvlist_t *nvtree, *nvl, *config = spa->spa_config;
-	int parse;
+	nvlist_t *nvroot = NULL;
+	nvlist_t *label;
 	vdev_t *rvd;
-	uint64_t pool_guid;
-	char *comment;
+	uberblock_t *ub = &spa->spa_uberblock;
+	uint64_t children, config_cache_txg = spa->spa_config_txg;
+	int orig_mode = spa->spa_mode;
+	int parse;
+	uint64_t obj;
+	boolean_t missing_feat_write = B_FALSE;
+	spa_meta_placement_t *mp;
 
 	/*
-	 * Versioning wasn't explicitly added to the label until later, so if
-	 * it's not present treat it as the initial version.
+	 * If this is an untrusted config, access the pool in read-only mode.
+	 * This prevents things like resilvering recently removed devices.
 	 */
-	if (nvlist_lookup_uint64(config, ZPOOL_CONFIG_VERSION,
-	    &spa->spa_ubsync.ub_version) != 0)
-		spa->spa_ubsync.ub_version = SPA_VERSION_INITIAL;
+	if (!mosconfig)
+		spa->spa_mode = FREAD;
 
-	if (nvlist_lookup_uint64(config, ZPOOL_CONFIG_POOL_GUID, &pool_guid)) {
-		spa_load_failed(spa, "invalid config provided: '%s' missing",
-		    ZPOOL_CONFIG_POOL_GUID);
-		return (SET_ERROR(EINVAL));
-	}
+	ASSERT(MUTEX_HELD(&spa_namespace_lock));
 
-	if ((spa->spa_load_state == SPA_LOAD_IMPORT || spa->spa_load_state ==
-	    SPA_LOAD_TRYIMPORT) && spa_guid_exists(pool_guid, 0)) {
-		spa_load_failed(spa, "a pool with guid %llu is already open",
-		    (u_longlong_t)pool_guid);
-		return (SET_ERROR(EEXIST));
-	}
+	spa->spa_load_state = state;
 
-	spa->spa_config_guid = pool_guid;
-
-	nvlist_free(spa->spa_load_info);
-	spa->spa_load_info = fnvlist_alloc();
-
-	ASSERT(spa->spa_comment == NULL);
-	if (nvlist_lookup_string(config, ZPOOL_CONFIG_COMMENT, &comment) == 0)
-		spa->spa_comment = spa_strdup(comment);
-
-	(void) nvlist_lookup_uint64(config, ZPOOL_CONFIG_POOL_TXG,
-	    &spa->spa_config_txg);
-
-	if (nvlist_lookup_nvlist(config, ZPOOL_CONFIG_SPLIT, &nvl) == 0)
-		spa->spa_config_splitting = fnvlist_dup(nvl);
-
-	if (nvlist_lookup_nvlist(config, ZPOOL_CONFIG_VDEV_TREE, &nvtree)) {
-		spa_load_failed(spa, "invalid config provided: '%s' missing",
-		    ZPOOL_CONFIG_VDEV_TREE);
+	if (nvlist_lookup_nvlist(config, ZPOOL_CONFIG_VDEV_TREE, &nvroot))
 		return (SET_ERROR(EINVAL));
-	}
 
+	parse = (type == SPA_IMPORT_EXISTING ?
+	    VDEV_ALLOC_LOAD : VDEV_ALLOC_SPLIT);
+
 	/*
 	 * Create "The Godfather" zio to hold all async IOs
 	 */
@@ -2336,16 +2447,11 @@
 	 * configuration requires knowing the version number.
 	 */
 	spa_config_enter(spa, SCL_ALL, FTAG, RW_WRITER);
-	parse = (type == SPA_IMPORT_EXISTING ?
-	    VDEV_ALLOC_LOAD : VDEV_ALLOC_SPLIT);
-	error = spa_config_parse(spa, &rvd, nvtree, NULL, 0, parse);
+	error = spa_config_parse(spa, &rvd, nvroot, NULL, 0, parse);
 	spa_config_exit(spa, SCL_ALL, FTAG);
 
-	if (error != 0) {
-		spa_load_failed(spa, "unable to parse config [error=%d]",
-		    error);
+	if (error != 0)
 		return (error);
-	}
 
 	ASSERT(spa->spa_root_vdev == rvd);
 	ASSERT3U(spa->spa_min_ashift, >=, SPA_MINBLOCKSHIFT);
@@ -2355,109 +2461,40 @@
 		ASSERT(spa_guid(spa) == pool_guid);
 	}
 
-	return (0);
-}
-
-/*
- * Recursively open all vdevs in the vdev tree. This function is called twice:
- * first with the untrusted config, then with the trusted config.
- */
-static int
-spa_ld_open_vdevs(spa_t *spa)
-{
-	int error = 0;
-
 	/*
-	 * spa_missing_tvds_allowed defines how many top-level vdevs can be
-	 * missing/unopenable for the root vdev to be still considered openable.
+	 * Try to open all vdevs, loading each label in the process.
 	 */
-	if (spa->spa_trust_config) {
-		spa->spa_missing_tvds_allowed = zfs_max_missing_tvds;
-	} else if (spa->spa_config_source == SPA_CONFIG_SRC_CACHEFILE) {
-		spa->spa_missing_tvds_allowed = zfs_max_missing_tvds_cachefile;
-	} else if (spa->spa_config_source == SPA_CONFIG_SRC_SCAN) {
-		spa->spa_missing_tvds_allowed = zfs_max_missing_tvds_scan;
-	} else {
-		spa->spa_missing_tvds_allowed = 0;
-	}
-
-	spa->spa_missing_tvds_allowed =
-	    MAX(zfs_max_missing_tvds, spa->spa_missing_tvds_allowed);
-
 	spa_config_enter(spa, SCL_ALL, FTAG, RW_WRITER);
-	error = vdev_open(spa->spa_root_vdev);
+	error = vdev_open(rvd);
 	spa_config_exit(spa, SCL_ALL, FTAG);
+	if (error != 0)
+		return (error);
 
-	if (spa->spa_missing_tvds != 0) {
-		spa_load_note(spa, "vdev tree has %lld missing top-level "
-		    "vdevs.", (u_longlong_t)spa->spa_missing_tvds);
-		if (spa->spa_trust_config && (spa->spa_mode & FWRITE)) {
-			/*
-			 * Although theoretically we could allow users to open
-			 * incomplete pools in RW mode, we'd need to add a lot
-			 * of extra logic (e.g. adjust pool space to account
-			 * for missing vdevs).
-			 * This limitation also prevents users from accidentally
-			 * opening the pool in RW mode during data recovery and
-			 * damaging it further.
-			 */
-			spa_load_note(spa, "pools with missing top-level "
-			    "vdevs can only be opened in read-only mode.");
-			error = SET_ERROR(ENXIO);
-		} else {
-			spa_load_note(spa, "current settings allow for maximum "
-			    "%lld missing top-level vdevs at this stage.",
-			    (u_longlong_t)spa->spa_missing_tvds_allowed);
-		}
-	}
-	if (error != 0) {
-		spa_load_failed(spa, "unable to open vdev tree [error=%d]",
-		    error);
-	}
-	if (spa->spa_missing_tvds != 0 || error != 0)
-		vdev_dbgmsg_print_tree(spa->spa_root_vdev, 2);
+	/*
+	 * We need to validate the vdev labels against the configuration that
+	 * we have in hand, which is dependent on the setting of mosconfig. If
+	 * mosconfig is true then we're validating the vdev labels based on
+	 * that config.  Otherwise, we're validating against the cached config
+	 * (zpool.cache) that was read when we loaded the zfs module, and then
+	 * later we will recursively call spa_load() and validate against
+	 * the vdev config.
+	 *
+	 * If we're assembling a new pool that's been split off from an
+	 * existing pool, the labels haven't yet been updated so we skip
+	 * validation for now.
+	 */
+	if (type != SPA_IMPORT_ASSEMBLE) {
+		spa_config_enter(spa, SCL_ALL, FTAG, RW_WRITER);
+		error = vdev_validate(rvd, mosconfig);
+		spa_config_exit(spa, SCL_ALL, FTAG);
 
-	return (error);
-}
+		if (error != 0)
+			return (error);
 
-/*
- * We need to validate the vdev labels against the configuration that
- * we have in hand. This function is called twice: first with an untrusted
- * config, then with a trusted config. The validation is more strict when the
- * config is trusted.
- */
-static int
-spa_ld_validate_vdevs(spa_t *spa)
-{
-	int error = 0;
-	vdev_t *rvd = spa->spa_root_vdev;
-
-	spa_config_enter(spa, SCL_ALL, FTAG, RW_WRITER);
-	error = vdev_validate(rvd);
-	spa_config_exit(spa, SCL_ALL, FTAG);
-
-	if (error != 0) {
-		spa_load_failed(spa, "vdev_validate failed [error=%d]", error);
-		return (error);
+		if (rvd->vdev_state <= VDEV_STATE_CANT_OPEN)
+			return (SET_ERROR(ENXIO));
 	}
 
-	if (rvd->vdev_state <= VDEV_STATE_CANT_OPEN) {
-		spa_load_failed(spa, "cannot open vdev tree after invalidating "
-		    "some vdevs");
-		vdev_dbgmsg_print_tree(rvd, 2);
-		return (SET_ERROR(ENXIO));
-	}
-
-	return (0);
-}
-
-static int
-spa_ld_select_uberblock(spa_t *spa, spa_import_type_t type)
-{
-	vdev_t *rvd = spa->spa_root_vdev;
-	nvlist_t *label;
-	uberblock_t *ub = &spa->spa_uberblock;
-
 	/*
 	 * Find the best uberblock.
 	 */
@@ -2468,20 +2505,14 @@
 	 */
 	if (ub->ub_txg == 0) {
 		nvlist_free(label);
-		spa_load_failed(spa, "no valid uberblock found");
 		return (spa_vdev_err(rvd, VDEV_AUX_CORRUPT_DATA, ENXIO));
 	}
 
-	spa_load_note(spa, "using uberblock with txg=%llu",
-	    (u_longlong_t)ub->ub_txg);
-
 	/*
 	 * If the pool has an unsupported version we can't open it.
 	 */
 	if (!SPA_VERSION_IS_SUPPORTED(ub->ub_version)) {
 		nvlist_free(label);
-		spa_load_failed(spa, "version %llu is not supported",
-		    (u_longlong_t)ub->ub_version);
 		return (spa_vdev_err(rvd, VDEV_AUX_VERSION_NEWER, ENOTSUP));
 	}
 
@@ -2492,17 +2523,9 @@
 		 * If we weren't able to find what's necessary for reading the
 		 * MOS in the label, return failure.
 		 */
-		if (label == NULL) {
-			spa_load_failed(spa, "label config unavailable");
-			return (spa_vdev_err(rvd, VDEV_AUX_CORRUPT_DATA,
-			    ENXIO));
-		}
-
-		if (nvlist_lookup_nvlist(label, ZPOOL_CONFIG_FEATURES_FOR_READ,
-		    &features) != 0) {
+		if (label == NULL || nvlist_lookup_nvlist(label,
+		    ZPOOL_CONFIG_FEATURES_FOR_READ, &features) != 0) {
 			nvlist_free(label);
-			spa_load_failed(spa, "invalid label: '%s' missing",
-			    ZPOOL_CONFIG_FEATURES_FOR_READ);
 			return (spa_vdev_err(rvd, VDEV_AUX_CORRUPT_DATA,
 			    ENXIO));
 		}
@@ -2541,7 +2564,6 @@
 			VERIFY(nvlist_add_nvlist(spa->spa_load_info,
 			    ZPOOL_CONFIG_UNSUP_FEAT, unsup_feat) == 0);
 			nvlist_free(unsup_feat);
-			spa_load_failed(spa, "some features are unsupported");
 			return (spa_vdev_err(rvd, VDEV_AUX_UNSUP_FEAT,
 			    ENOTSUP));
 		}
@@ -2549,9 +2571,21 @@
 		nvlist_free(unsup_feat);
 	}
 
+	/*
+	 * If the vdev guid sum doesn't match the uberblock, we have an
+	 * incomplete configuration.  We first check to see if the pool
+	 * is aware of the complete config (i.e ZPOOL_CONFIG_VDEV_CHILDREN).
+	 * If it is, defer the vdev_guid_sum check till later so we
+	 * can handle missing vdevs.
+	 */
+	if (nvlist_lookup_uint64(config, ZPOOL_CONFIG_VDEV_CHILDREN,
+	    &children) != 0 && mosconfig && type != SPA_IMPORT_ASSEMBLE &&
+	    rvd->vdev_guid_sum != ub->ub_guid_sum)
+		return (spa_vdev_err(rvd, VDEV_AUX_BAD_GUID_SUM, ENXIO));
+
 	if (type != SPA_IMPORT_ASSEMBLE && spa->spa_config_splitting) {
 		spa_config_enter(spa, SCL_ALL, FTAG, RW_WRITER);
-		spa_try_repair(spa, spa->spa_config);
+		spa_try_repair(spa, config);
 		spa_config_exit(spa, SCL_ALL, FTAG);
 		nvlist_free(spa->spa_config_splitting);
 		spa->spa_config_splitting = NULL;
@@ -2569,243 +2603,30 @@
 	spa->spa_claim_max_txg = spa->spa_first_txg;
 	spa->spa_prev_software_version = ub->ub_software_version;
 
-	return (0);
-}
-
-static int
-spa_ld_open_rootbp(spa_t *spa)
-{
-	int error = 0;
-	vdev_t *rvd = spa->spa_root_vdev;
-
 	error = dsl_pool_init(spa, spa->spa_first_txg, &spa->spa_dsl_pool);
-	if (error != 0) {
-		spa_load_failed(spa, "unable to open rootbp in dsl_pool_init "
-		    "[error=%d]", error);
+	if (error)
 		return (spa_vdev_err(rvd, VDEV_AUX_CORRUPT_DATA, EIO));
-	}
 	spa->spa_meta_objset = spa->spa_dsl_pool->dp_meta_objset;
 
-	return (0);
-}
-
-static int
-spa_ld_load_trusted_config(spa_t *spa, spa_import_type_t type,
-    boolean_t reloading)
-{
-	vdev_t *mrvd, *rvd = spa->spa_root_vdev;
-	nvlist_t *nv, *mos_config, *policy;
-	int error = 0, copy_error;
-	uint64_t healthy_tvds, healthy_tvds_mos;
-	uint64_t mos_config_txg;
-
-	if (spa_dir_prop(spa, DMU_POOL_CONFIG, &spa->spa_config_object, B_TRUE)
-	    != 0)
+	if (spa_dir_prop(spa, DMU_POOL_CONFIG, &spa->spa_config_object) != 0)
 		return (spa_vdev_err(rvd, VDEV_AUX_CORRUPT_DATA, EIO));
 
-	/*
-	 * If we're assembling a pool from a split, the config provided is
-	 * already trusted so there is nothing to do.
-	 */
-	if (type == SPA_IMPORT_ASSEMBLE)
-		return (0);
-
-	healthy_tvds = spa_healthy_core_tvds(spa);
-
-	if (load_nvlist(spa, spa->spa_config_object, &mos_config)
-	    != 0) {
-		spa_load_failed(spa, "unable to retrieve MOS config");
-		return (spa_vdev_err(rvd, VDEV_AUX_CORRUPT_DATA, EIO));
-	}
-
-	/*
-	 * If we are doing an open, pool owner wasn't verified yet, thus do
-	 * the verification here.
-	 */
-	if (spa->spa_load_state == SPA_LOAD_OPEN) {
-		error = spa_verify_host(spa, mos_config);
-		if (error != 0) {
-			nvlist_free(mos_config);
-			return (error);
-		}
-	}
-
-	nv = fnvlist_lookup_nvlist(mos_config, ZPOOL_CONFIG_VDEV_TREE);
-
-	spa_config_enter(spa, SCL_ALL, FTAG, RW_WRITER);
-
-	/*
-	 * Build a new vdev tree from the trusted config
-	 */
-	VERIFY(spa_config_parse(spa, &mrvd, nv, NULL, 0, VDEV_ALLOC_LOAD) == 0);
-
-	/*
-	 * Vdev paths in the MOS may be obsolete. If the untrusted config was
-	 * obtained by scanning /dev/dsk, then it will have the right vdev
-	 * paths. We update the trusted MOS config with this information.
-	 * We first try to copy the paths with vdev_copy_path_strict, which
-	 * succeeds only when both configs have exactly the same vdev tree.
-	 * If that fails, we fall back to a more flexible method that has a
-	 * best effort policy.
-	 */
-	copy_error = vdev_copy_path_strict(rvd, mrvd);
-	if (copy_error != 0 || spa_load_print_vdev_tree) {
-		spa_load_note(spa, "provided vdev tree:");
-		vdev_dbgmsg_print_tree(rvd, 2);
-		spa_load_note(spa, "MOS vdev tree:");
-		vdev_dbgmsg_print_tree(mrvd, 2);
-	}
-	if (copy_error != 0) {
-		spa_load_note(spa, "vdev_copy_path_strict failed, falling "
-		    "back to vdev_copy_path_relaxed");
-		vdev_copy_path_relaxed(rvd, mrvd);
-	}
-
-	vdev_close(rvd);
-	vdev_free(rvd);
-	spa->spa_root_vdev = mrvd;
-	rvd = mrvd;
-	spa_config_exit(spa, SCL_ALL, FTAG);
-
-	/*
-	 * We will use spa_config if we decide to reload the spa or if spa_load
-	 * fails and we rewind. We must thus regenerate the config using the
-	 * MOS information with the updated paths. Rewind policy is an import
-	 * setting and is not in the MOS. We copy it over to our new, trusted
-	 * config.
-	 */
-	mos_config_txg = fnvlist_lookup_uint64(mos_config,
-	    ZPOOL_CONFIG_POOL_TXG);
-	nvlist_free(mos_config);
-	mos_config = spa_config_generate(spa, NULL, mos_config_txg, B_FALSE);
-	if (nvlist_lookup_nvlist(spa->spa_config, ZPOOL_REWIND_POLICY,
-	    &policy) == 0)
-		fnvlist_add_nvlist(mos_config, ZPOOL_REWIND_POLICY, policy);
-	spa_config_set(spa, mos_config);
-	spa->spa_config_source = SPA_CONFIG_SRC_MOS;
-
-	/*
-	 * Now that we got the config from the MOS, we should be more strict
-	 * in checking blkptrs and can make assumptions about the consistency
-	 * of the vdev tree. spa_trust_config must be set to true before opening
-	 * vdevs in order for them to be writeable.
-	 */
-	spa->spa_trust_config = B_TRUE;
-
-	/*
-	 * Open and validate the new vdev tree
-	 */
-	error = spa_ld_open_vdevs(spa);
-	if (error != 0)
-		return (error);
-
-	error = spa_ld_validate_vdevs(spa);
-	if (error != 0)
-		return (error);
-
-	if (copy_error != 0 || spa_load_print_vdev_tree) {
-		spa_load_note(spa, "final vdev tree:");
-		vdev_dbgmsg_print_tree(rvd, 2);
-	}
-
-	if (spa->spa_load_state != SPA_LOAD_TRYIMPORT &&
-	    !spa->spa_extreme_rewind && zfs_max_missing_tvds == 0) {
-		/*
-		 * Sanity check to make sure that we are indeed loading the
-		 * latest uberblock. If we missed SPA_SYNC_MIN_VDEVS tvds
-		 * in the config provided and they happened to be the only ones
-		 * to have the latest uberblock, we could involuntarily perform
-		 * an extreme rewind.
-		 */
-		healthy_tvds_mos = spa_healthy_core_tvds(spa);
-		if (healthy_tvds_mos - healthy_tvds >=
-		    SPA_SYNC_MIN_VDEVS) {
-			spa_load_note(spa, "config provided misses too many "
-			    "top-level vdevs compared to MOS (%lld vs %lld). ",
-			    (u_longlong_t)healthy_tvds,
-			    (u_longlong_t)healthy_tvds_mos);
-			spa_load_note(spa, "vdev tree:");
-			vdev_dbgmsg_print_tree(rvd, 2);
-			if (reloading) {
-				spa_load_failed(spa, "config was already "
-				    "provided from MOS. Aborting.");
-				return (spa_vdev_err(rvd,
-				    VDEV_AUX_CORRUPT_DATA, EIO));
-			}
-			spa_load_note(spa, "spa must be reloaded using MOS "
-			    "config");
-			return (SET_ERROR(EAGAIN));
-		}
-	}
-
-	error = spa_check_for_missing_logs(spa);
-	if (error != 0)
-		return (spa_vdev_err(rvd, VDEV_AUX_BAD_GUID_SUM, ENXIO));
-
-	if (rvd->vdev_guid_sum != spa->spa_uberblock.ub_guid_sum) {
-		spa_load_failed(spa, "uberblock guid sum doesn't match MOS "
-		    "guid sum (%llu != %llu)",
-		    (u_longlong_t)spa->spa_uberblock.ub_guid_sum,
-		    (u_longlong_t)rvd->vdev_guid_sum);
-		return (spa_vdev_err(rvd, VDEV_AUX_BAD_GUID_SUM,
-		    ENXIO));
-	}
-
-	return (0);
-}
-
-static int
-spa_ld_open_indirect_vdev_metadata(spa_t *spa)
-{
-	int error = 0;
-	vdev_t *rvd = spa->spa_root_vdev;
-
-	/*
-	 * Everything that we read before spa_remove_init() must be stored
-	 * on concreted vdevs.  Therefore we do this as early as possible.
-	 */
-	error = spa_remove_init(spa);
-	if (error != 0) {
-		spa_load_failed(spa, "spa_remove_init failed [error=%d]",
-		    error);
-		return (spa_vdev_err(rvd, VDEV_AUX_CORRUPT_DATA, EIO));
-	}
-
-	/*
-	 * Retrieve information needed to condense indirect vdev mappings.
-	 */
-	error = spa_condense_init(spa);
-	if (error != 0) {
-		spa_load_failed(spa, "spa_condense_init failed [error=%d]",
-		    error);
-		return (spa_vdev_err(rvd, VDEV_AUX_CORRUPT_DATA, error));
-	}
-
-	return (0);
-}
-
-static int
-spa_ld_check_features(spa_t *spa, boolean_t *missing_feat_writep)
-{
-	int error = 0;
-	vdev_t *rvd = spa->spa_root_vdev;
-
 	if (spa_version(spa) >= SPA_VERSION_FEATURES) {
 		boolean_t missing_feat_read = B_FALSE;
 		nvlist_t *unsup_feat, *enabled_feat;
 
 		if (spa_dir_prop(spa, DMU_POOL_FEATURES_FOR_READ,
-		    &spa->spa_feat_for_read_obj, B_TRUE) != 0) {
+		    &spa->spa_feat_for_read_obj) != 0) {
 			return (spa_vdev_err(rvd, VDEV_AUX_CORRUPT_DATA, EIO));
 		}
 
 		if (spa_dir_prop(spa, DMU_POOL_FEATURES_FOR_WRITE,
-		    &spa->spa_feat_for_write_obj, B_TRUE) != 0) {
+		    &spa->spa_feat_for_write_obj) != 0) {
 			return (spa_vdev_err(rvd, VDEV_AUX_CORRUPT_DATA, EIO));
 		}
 
 		if (spa_dir_prop(spa, DMU_POOL_FEATURE_DESCRIPTIONS,
-		    &spa->spa_feat_desc_obj, B_TRUE) != 0) {
+		    &spa->spa_feat_desc_obj) != 0) {
 			return (spa_vdev_err(rvd, VDEV_AUX_CORRUPT_DATA, EIO));
 		}
 
@@ -2816,11 +2637,10 @@
 		    unsup_feat, enabled_feat))
 			missing_feat_read = B_TRUE;
 
-		if (spa_writeable(spa) ||
-		    spa->spa_load_state == SPA_LOAD_TRYIMPORT) {
+		if (spa_writeable(spa) || state == SPA_LOAD_TRYIMPORT) {
 			if (!spa_features_check(spa, B_TRUE,
 			    unsup_feat, enabled_feat)) {
-				*missing_feat_writep = B_TRUE;
+				missing_feat_write = B_TRUE;
 			}
 		}
 
@@ -2859,9 +2679,8 @@
 		 * userland in order to know whether to display the
 		 * abovementioned note.
 		 */
-		if (missing_feat_read || (*missing_feat_writep &&
+		if (missing_feat_read || (missing_feat_write &&
 		    spa_writeable(spa))) {
-			spa_load_failed(spa, "pool uses unsupported features");
 			return (spa_vdev_err(rvd, VDEV_AUX_UNSUP_FEAT,
 			    ENOTSUP));
 		}
@@ -2881,9 +2700,6 @@
 				spa->spa_feat_refcount_cache[i] =
 				    SPA_FEATURE_DISABLED;
 			} else {
-				spa_load_failed(spa, "error getting refcount "
-				    "for feature %s [error=%d]",
-				    spa_feature_table[i].fi_guid, error);
 				return (spa_vdev_err(rvd,
 				    VDEV_AUX_CORRUPT_DATA, EIO));
 			}
@@ -2892,37 +2708,65 @@
 
 	if (spa_feature_is_active(spa, SPA_FEATURE_ENABLED_TXG)) {
 		if (spa_dir_prop(spa, DMU_POOL_FEATURE_ENABLED_TXG,
-		    &spa->spa_feat_enabled_txg_obj, B_TRUE) != 0)
+		    &spa->spa_feat_enabled_txg_obj) != 0)
 			return (spa_vdev_err(rvd, VDEV_AUX_CORRUPT_DATA, EIO));
 	}
 
-	return (0);
-}
-
-static int
-spa_ld_load_special_directories(spa_t *spa)
-{
-	int error = 0;
-	vdev_t *rvd = spa->spa_root_vdev;
-
 	spa->spa_is_initializing = B_TRUE;
 	error = dsl_pool_open(spa->spa_dsl_pool);
 	spa->spa_is_initializing = B_FALSE;
-	if (error != 0) {
-		spa_load_failed(spa, "dsl_pool_open failed [error=%d]", error);
+	if (error != 0)
 		return (spa_vdev_err(rvd, VDEV_AUX_CORRUPT_DATA, EIO));
-	}
 
-	return (0);
-}
+	if (!mosconfig) {
+		uint64_t hostid;
+		nvlist_t *policy = NULL, *nvconfig;
 
-static int
-spa_ld_get_props(spa_t *spa)
-{
-	int error = 0;
-	uint64_t obj;
-	vdev_t *rvd = spa->spa_root_vdev;
+		if (load_nvlist(spa, spa->spa_config_object, &nvconfig) != 0)
+			return (spa_vdev_err(rvd, VDEV_AUX_CORRUPT_DATA, EIO));
 
+		if (!spa_is_root(spa) && nvlist_lookup_uint64(nvconfig,
+		    ZPOOL_CONFIG_HOSTID, &hostid) == 0) {
+			char *hostname;
+			unsigned long myhostid = 0;
+
+			VERIFY(nvlist_lookup_string(nvconfig,
+			    ZPOOL_CONFIG_HOSTNAME, &hostname) == 0);
+
+#ifdef	_KERNEL
+			myhostid = zone_get_hostid(NULL);
+#else	/* _KERNEL */
+			/*
+			 * We're emulating the system's hostid in userland, so
+			 * we can't use zone_get_hostid().
+			 */
+			(void) ddi_strtoul(hw_serial, NULL, 10, &myhostid);
+#endif	/* _KERNEL */
+			if (hostid != 0 && myhostid != 0 &&
+			    hostid != myhostid) {
+				nvlist_free(nvconfig);
+				cmn_err(CE_WARN, "pool '%s' could not be "
+				    "loaded as it was last accessed by "
+				    "another system (host: %s hostid: 0x%lx). "
+				    "See: http://illumos.org/msg/ZFS-8000-EY",
+				    spa_name(spa), hostname,
+				    (unsigned long)hostid);
+				return (SET_ERROR(EBADF));
+			}
+		}
+		if (nvlist_lookup_nvlist(spa->spa_config,
+		    ZPOOL_REWIND_POLICY, &policy) == 0)
+			VERIFY(nvlist_add_nvlist(nvconfig,
+			    ZPOOL_REWIND_POLICY, policy) == 0);
+
+		spa_config_set(spa, nvconfig);
+		spa_unload(spa);
+		spa_deactivate(spa);
+		spa_activate(spa, orig_mode);
+
+		return (spa_load(spa, state, SPA_IMPORT_EXISTING, B_TRUE));
+	}
+
 	/* Grab the secret checksum salt from the MOS. */
 	error = zap_lookup(spa->spa_meta_objset, DMU_POOL_DIRECTORY_OBJECT,
 	    DMU_POOL_CHECKSUM_SALT, 1,
@@ -2933,19 +2777,14 @@
 		(void) random_get_pseudo_bytes(spa->spa_cksum_salt.zcs_bytes,
 		    sizeof (spa->spa_cksum_salt.zcs_bytes));
 	} else if (error != 0) {
-		spa_load_failed(spa, "unable to retrieve checksum salt from "
-		    "MOS [error=%d]", error);
 		return (spa_vdev_err(rvd, VDEV_AUX_CORRUPT_DATA, EIO));
 	}
 
-	if (spa_dir_prop(spa, DMU_POOL_SYNC_BPOBJ, &obj, B_TRUE) != 0)
+	if (spa_dir_prop(spa, DMU_POOL_SYNC_BPOBJ, &obj) != 0)
 		return (spa_vdev_err(rvd, VDEV_AUX_CORRUPT_DATA, EIO));
 	error = bpobj_open(&spa->spa_deferred_bpobj, spa->spa_meta_objset, obj);
-	if (error != 0) {
-		spa_load_failed(spa, "error opening deferred-frees bpobj "
-		    "[error=%d]", error);
+	if (error != 0)
 		return (spa_vdev_err(rvd, VDEV_AUX_CORRUPT_DATA, EIO));
-	}
 
 	/*
 	 * Load the bit that tells us to use the new accounting function
@@ -2952,12 +2791,12 @@
 	 * (raid-z deflation).  If we have an older pool, this will not
 	 * be present.
 	 */
-	error = spa_dir_prop(spa, DMU_POOL_DEFLATE, &spa->spa_deflate, B_FALSE);
+	error = spa_dir_prop(spa, DMU_POOL_DEFLATE, &spa->spa_deflate);
 	if (error != 0 && error != ENOENT)
 		return (spa_vdev_err(rvd, VDEV_AUX_CORRUPT_DATA, EIO));
 
 	error = spa_dir_prop(spa, DMU_POOL_CREATION_VERSION,
-	    &spa->spa_creation_version, B_FALSE);
+	    &spa->spa_creation_version);
 	if (error != 0 && error != ENOENT)
 		return (spa_vdev_err(rvd, VDEV_AUX_CORRUPT_DATA, EIO));
 
@@ -2965,13 +2804,12 @@
 	 * Load the persistent error log.  If we have an older pool, this will
 	 * not be present.
 	 */
-	error = spa_dir_prop(spa, DMU_POOL_ERRLOG_LAST, &spa->spa_errlog_last,
-	    B_FALSE);
+	error = spa_dir_prop(spa, DMU_POOL_ERRLOG_LAST, &spa->spa_errlog_last);
 	if (error != 0 && error != ENOENT)
 		return (spa_vdev_err(rvd, VDEV_AUX_CORRUPT_DATA, EIO));
 
 	error = spa_dir_prop(spa, DMU_POOL_ERRLOG_SCRUB,
-	    &spa->spa_errlog_scrub, B_FALSE);
+	    &spa->spa_errlog_scrub);
 	if (error != 0 && error != ENOENT)
 		return (spa_vdev_err(rvd, VDEV_AUX_CORRUPT_DATA, EIO));
 
@@ -2979,7 +2817,7 @@
 	 * Load the history object.  If we have an older pool, this
 	 * will not be present.
 	 */
-	error = spa_dir_prop(spa, DMU_POOL_HISTORY, &spa->spa_history, B_FALSE);
+	error = spa_dir_prop(spa, DMU_POOL_HISTORY, &spa->spa_history);
 	if (error != 0 && error != ENOENT)
 		return (spa_vdev_err(rvd, VDEV_AUX_CORRUPT_DATA, EIO));
 
@@ -2992,13 +2830,11 @@
 
 	/* The sentinel is only available in the MOS config. */
 	nvlist_t *mos_config;
-	if (load_nvlist(spa, spa->spa_config_object, &mos_config) != 0) {
-		spa_load_failed(spa, "unable to retrieve MOS config");
+	if (load_nvlist(spa, spa->spa_config_object, &mos_config) != 0)
 		return (spa_vdev_err(rvd, VDEV_AUX_CORRUPT_DATA, EIO));
-	}
 
 	error = spa_dir_prop(spa, DMU_POOL_VDEV_ZAP_MAP,
-	    &spa->spa_all_vdev_zaps, B_FALSE);
+	    &spa->spa_all_vdev_zaps);
 
 	if (error == ENOENT) {
 		VERIFY(!nvlist_exists(mos_config,
@@ -3022,50 +2858,7 @@
 	}
 	nvlist_free(mos_config);
 
-	spa->spa_delegation = zpool_prop_default_numeric(ZPOOL_PROP_DELEGATION);
-
-	error = spa_dir_prop(spa, DMU_POOL_PROPS, &spa->spa_pool_props_object,
-	    B_FALSE);
-	if (error && error != ENOENT)
-		return (spa_vdev_err(rvd, VDEV_AUX_CORRUPT_DATA, EIO));
-
-	if (error == 0) {
-		uint64_t autoreplace;
-
-		spa_prop_find(spa, ZPOOL_PROP_BOOTFS, &spa->spa_bootfs);
-		spa_prop_find(spa, ZPOOL_PROP_AUTOREPLACE, &autoreplace);
-		spa_prop_find(spa, ZPOOL_PROP_DELEGATION, &spa->spa_delegation);
-		spa_prop_find(spa, ZPOOL_PROP_FAILUREMODE, &spa->spa_failmode);
-		spa_prop_find(spa, ZPOOL_PROP_AUTOEXPAND, &spa->spa_autoexpand);
-		spa_prop_find(spa, ZPOOL_PROP_DEDUPDITTO,
-		    &spa->spa_dedup_ditto);
-
-		spa->spa_autoreplace = (autoreplace != 0);
-	}
-
 	/*
-	 * If we are importing a pool with missing top-level vdevs,
-	 * we enforce that the pool doesn't panic or get suspended on
-	 * error since the likelihood of missing data is extremely high.
-	 */
-	if (spa->spa_missing_tvds > 0 &&
-	    spa->spa_failmode != ZIO_FAILURE_MODE_CONTINUE &&
-	    spa->spa_load_state != SPA_LOAD_TRYIMPORT) {
-		spa_load_note(spa, "forcing failmode to 'continue' "
-		    "as some top level vdevs are missing");
-		spa->spa_failmode = ZIO_FAILURE_MODE_CONTINUE;
-	}
-
-	return (0);
-}
-
-static int
-spa_ld_open_aux_vdevs(spa_t *spa, spa_import_type_t type)
-{
-	int error = 0;
-	vdev_t *rvd = spa->spa_root_vdev;
-
-	/*
 	 * If we're assembling the pool from the split-off vdevs of
 	 * an existing pool, we don't want to attach the spares & cache
 	 * devices.
@@ -3074,17 +2867,14 @@
 	/*
 	 * Load any hot spares for this pool.
 	 */
-	error = spa_dir_prop(spa, DMU_POOL_SPARES, &spa->spa_spares.sav_object,
-	    B_FALSE);
+	error = spa_dir_prop(spa, DMU_POOL_SPARES, &spa->spa_spares.sav_object);
 	if (error != 0 && error != ENOENT)
 		return (spa_vdev_err(rvd, VDEV_AUX_CORRUPT_DATA, EIO));
 	if (error == 0 && type != SPA_IMPORT_ASSEMBLE) {
 		ASSERT(spa_version(spa) >= SPA_VERSION_SPARES);
 		if (load_nvlist(spa, spa->spa_spares.sav_object,
-		    &spa->spa_spares.sav_config) != 0) {
-			spa_load_failed(spa, "error loading spares nvlist");
+		    &spa->spa_spares.sav_config) != 0)
 			return (spa_vdev_err(rvd, VDEV_AUX_CORRUPT_DATA, EIO));
-		}
 
 		spa_config_enter(spa, SCL_ALL, FTAG, RW_WRITER);
 		spa_load_spares(spa);
@@ -3097,16 +2887,14 @@
 	 * Load any level 2 ARC devices for this pool.
 	 */
 	error = spa_dir_prop(spa, DMU_POOL_L2CACHE,
-	    &spa->spa_l2cache.sav_object, B_FALSE);
+	    &spa->spa_l2cache.sav_object);
 	if (error != 0 && error != ENOENT)
 		return (spa_vdev_err(rvd, VDEV_AUX_CORRUPT_DATA, EIO));
 	if (error == 0 && type != SPA_IMPORT_ASSEMBLE) {
 		ASSERT(spa_version(spa) >= SPA_VERSION_L2CACHE);
 		if (load_nvlist(spa, spa->spa_l2cache.sav_object,
-		    &spa->spa_l2cache.sav_config) != 0) {
-			spa_load_failed(spa, "error loading l2cache nvlist");
+		    &spa->spa_l2cache.sav_config) != 0)
 			return (spa_vdev_err(rvd, VDEV_AUX_CORRUPT_DATA, EIO));
-		}
 
 		spa_config_enter(spa, SCL_ALL, FTAG, RW_WRITER);
 		spa_load_l2cache(spa);
